﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Data;
using System.Diagnostics;
using Infragistics.Windows;
using System.Windows.Controls.Primitives;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace Test
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<Person> collection { get; set; }
        int flag = 0;
        public static int GlobalFlag = 0;

        public MainWindow()
        {
            InitializeComponent();

            collection = new ObservableCollection<Person>();

            collection.Add(new Person() { Name = "Ivan1", Age = 20 });
            collection.Add(new Person() { Name = "Ivan2", Age = 50 });
            collection.Add(new Person() { Name = "Ivan3", Age = 30 });
            collection.Add(new Person() { Name = "Ivan4", Age = 40 });

            this.DataContext = collection;
            
        }

        private void xamDataGrid1_EditModeEnding(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs e)
        {
            if(flag == 0)
            {
                PopUp pu = new PopUp();
                pu.ShowDialog();
            }
        }

        private void Window_Closing(object sender, CancelEventArgs e)
        {
            flag = 1;
        }
        
    }

    public class Person : INotifyPropertyChanged
    {
        private String name;
        private int age;

        public String Name
        {
            get { return this.name; }

            set
            {
                if (MainWindow.GlobalFlag == 0)
                {
                    if (value != this.name)
                    {
                        this.name = value;
                        NotifyPropertyChanged("Name");
                    }
                }
                MainWindow.GlobalFlag = 0;
            }
        }

        public int Age
        {
            get { return this.age; }

            set
            {
                if (MainWindow.GlobalFlag == 0)
                {
                    if (value != this.age)
                    {
                        this.age = value;
                        NotifyPropertyChanged("Age");
                    }
                }
                MainWindow.GlobalFlag = 0;
            }
        }

        

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
}
